package main

import (
	"log"

	"code.rocketnine.space/tslocum/beehive"
)

type Config struct {
	// Address to listen on.
	Listen string

	// Path to festoons.
	FestoonsDir string

	// map[ID]Password
	Workers map[int]string
}

var config = &Config{}

func parseConfig(configPath string) {
	err := beehive.Deserialize(config, configPath)
	if err != nil {
		log.Fatal(err)
	}

	if config.Listen == "" {
		log.Fatal("listen address is required")
	}

	if config.FestoonsDir == "" {
		log.Fatal("festoons path is required")
	}

	if len(config.Workers) == 0 {
		log.Fatal("at least one worker must be defined")
	}
}
