package main

import (
	"flag"
	"log"

	"code.rocketnine.space/tslocum/beehive"

	_ "github.com/lib/pq"
)

func main() {
	var (
		configPath string
	)
	flag.StringVar(&configPath, "config", "", "path to configuration file")
	flag.Parse()

	parseConfig(configPath)

	log.Println("Connecting to database...")
	connStr := "postgres://queenbee:queenbee@localhost/queenbee?sslmode=disable&connect_timeout=5"
	var err error
	beehive.DB, err = beehive.NewDatabase("postgres", connStr)
	if err != nil {
		log.Fatal(err)
	}
	log.Println("Connected successfully")

	log.Println("Listening for worker connections")
	s, err := beehive.NewServer(config.Listen, config.Workers)
	if err != nil {
		log.Fatal(err)
	}

	// TODO submit a task to a worker

	// TODO port range available is 10000-49151

	_ = s
	select {}
}
