package main

import (
	"log"
	"strings"

	"code.rocketnine.space/tslocum/beehive"
)

type Config struct {
	// Path to festoons.
	Festoons string

	// Path to deployments.
	Deployments string

	// Address to connect to queen bee.
	Queen string

	// Worker IP address.
	IP string

	// Unique ID.
	ID int

	// Password.
	Password string
}

var config = &Config{}

func parseConfig(configPath string) {
	if strings.TrimSpace(configPath) == "" {
		log.Fatal("path to configuration file is required")
	}

	err := beehive.Deserialize(config, configPath)
	if err != nil {
		log.Fatal(err)
	}

	if config.ID == 0 {
		log.Fatal("worker ID is required")
	}

	if strings.TrimSpace(config.Queen) == "" {
		log.Fatal("queen bee address is required")
	}

	if strings.TrimSpace(config.Password) == "" {
		log.Fatal("password is required")
	}

	if strings.TrimSpace(config.Deployments) == "" {
		log.Fatal("deployments path is required")
	}

	if strings.TrimSpace(config.Festoons) == "" {
		log.Fatal("festoons path is required")
	} else if strings.HasSuffix(config.Festoons, "/") {
		config.Festoons = strings.TrimSuffix(config.Festoons, "/")
	}
}
